from __future__ import print_function
import socket
import concurrent.futures
import urllib.request
import random
import time
import sys
import libvirt
import config

TCP_IP = '192.168.123.174'
TCP_PORT = 9001
BUFFER_SIZE = 1024

# server_ips = ['192.168.123.174'] 
server_ips = config.new_server_ips


def send_request(request, server_index):
    s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    s.connect((server_ips[server_index], TCP_PORT))
    s.send(request.encode('ascii'))
    data = s.recv(BUFFER_SIZE)
    s.close()
    return data

request = '3,50'
server_index = 0

conn = libvirt.open('qemu:///system')
if conn == None:
    print('Failed to open connection to qemu:///system', file=sys.stderr)
    exit(1)

i = 0
while(True) :
    if(i < 10):
        l = [request] * 100
    else :
        l = [request] * 200
    server_index = (server_index + 1) % len(server_ips)
    f = open('server_ips.txt', 'r')
    server_ips = [line.strip() for line in f.readlines()]
    # print(config.new_server_ips)
    # print(server_ips)
    print(server_index)
    # for lease in conn.networkLookupByName("default").DHCPLeases():
    #     if lease['ipaddr'] not in server_ips:
    #         server_ips.append(lease['ipaddr'])
    with concurrent.futures.ThreadPoolExecutor(max_workers=2) as executor:
        req_sender = [executor.submit(send_request, request, server_index) for request in l]
        for future in concurrent.futures.as_completed(req_sender):
            data = future.result()
            # print(data)
    i += 1
    time.sleep(0.5)